<?php
	/*******************************************
	*        admin_uploadpic_users.php         *
	*        -------------------------         *
	*                                          *
	*   date       : 08/2005 - 03/2007         *
	*   version    : 1.3.4                     *
	*   (C)/author : B.Funke                   *
	*   PayPal     : paypal@beehave.de         *
	*   URL        : http://forum.beehave.de   *
	*                                          *
	********************************************/

/* UploadPic can be freely copied and used, as long as all provided files remain unchanged. */
/* For all further terms, the GNU GENERAL PUBLIC LICENSE applies to this MOD. */


	// Start
	define('IN_PHPBB', 1);

	if( !empty($setmodules) )
	{
		$filename = basename(__FILE__);
		$module['UploadPic']['UploadPic_menu_users'] = $filename;
		return;
	}


	// Include required files, get $phpEx and check permissions
	$phpbb_root_path = "./../";
	require($phpbb_root_path . 'extension.inc');
	require('./pagestart.' . $phpEx);


	// Start
    $template->set_filenames(array('body' => 'admin/admin_uploadpic_users.tpl'));

	$start = ( isset($HTTP_GET_VARS['start']) ) ? max(0, intval($HTTP_GET_VARS['start'])) : 0;

	// bulk-change permissions
	if (!empty($HTTP_POST_VARS['GO']))
	{
		// remove permissions of all users on current page
		$sql= "UPDATE ".USERS_TABLE."
				SET user_allow_uploadpic = 0
				WHERE user_id IN (".implode(",",$HTTP_POST_VARS['arr_userid']).")";
		$result = $db->sql_query($sql);

		if (count($HTTP_POST_VARS['arr_user']))
		{
			// set permissons
			$sql= "UPDATE ".USERS_TABLE."
					SET user_allow_uploadpic = 1
					WHERE user_id IN (".implode(",",$HTTP_POST_VARS['arr_user']).")";
			$result = $db->sql_query($sql);
		}
	}

	// allow/disallow for ALL users
	if($HTTP_GET_VARS['action'] == "allowall")
	{
		$sql= "UPDATE ".USERS_TABLE." SET user_allow_uploadpic = 1";
		$result = $db->sql_query($sql);
		$template->assign_block_vars('switch_permissionschanged', array());
	}
	else if($HTTP_GET_VARS['action'] == "disallowall")
	{
		$sql= "UPDATE ".USERS_TABLE." SET user_allow_uploadpic = 0";
		$result = $db->sql_query($sql);
		$template->assign_block_vars('switch_permissionschanged', array());
	}


	// get first letters of all usernames
	$sql= "SELECT username FROM ".USERS_TABLE." WHERE user_id > 0 ORDER BY LEFT(username,1)";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, '', '', __LINE__, __FILE__, $sql);
	}

	$str_unstartalt = "";
	$str_navigation = "";
	$int_sletter = 0;
	$int_count = $db->sql_numrows($result);

	while ( $row = $db->sql_fetchrow($result) )
	{
		$str_first = strtoupper(substr($row['username'],0,1));

		if ($str_first != $str_unstartalt)
		{
			$str_navigation .= '<a href="'.append_sid('admin_uploadpic_users.'.$phpEx.'?start='.(floor($int_sletter/$board_config['topics_per_page']) * $board_config['topics_per_page'])).'"><strong>'.$str_first.'</strong></a> ';
		}

		$str_unstartalt = $str_first;
		$int_sletter++;
	}

	// get users
	$sql= "SELECT user_id, username, user_allow_uploadpic
			FROM ".USERS_TABLE."
			WHERE user_id > 0
			ORDER BY username
			LIMIT ".$start.", ".$board_config['topics_per_page'];
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, '', '', __LINE__, __FILE__, $sql);
	}

	$str_unstartalt = "";
	$int_selected = 0;

	while ( $row = $db->sql_fetchrow($result) )
	{
		$str_first = strtoupper(substr($row['username'],0,1));

		$template->assign_block_vars('users_row', array(
			'ROW_USERID' => $row['user_id'],
			'ROW_USERNAME' => $row['username'],
			'ROW_CHECKED' => ($row['user_allow_uploadpic'] == 1) ? 'checked="checked"' : '',
			'ROW_FIRST' => $str_first
		));

		if ($str_first != $str_unstartalt)
		{
			$template->assign_block_vars('users_row.switch_newline', array());
		}

		$int_selected = ($row['user_allow_uploadpic'] == 1) ? $int_selected+1 : $int_selected;
		$str_unstartalt = $str_first;
	}

	$str_pagination = generate_pagination("admin_uploadpic_users.".$phpEx."?", $int_count, $board_config['topics_per_page'], $start);

	$template->assign_vars(array(
		'L_TITLE' => $lang['UploadPic_menu_users'],
		'L_CHANGEMESSAGE' => $lang['UP_PermChanged'],
		'L_PERMISSIONS' => $lang['UP_Permissions'],
		'L_ALLNONE' => $lang['UP_AllNone'],
		'V_ALLNONE_CHECKED' => ($int_count == $int_selected) ? 'checked="checked"' : '',
		'URL_ALLOWALL' => '<a href="'.append_sid($HTTP_SERVER_VARS['PHP_SELF'].'?action=allowall').'" onclick="return confirm(\''.$lang['UP_AllowAll'].'?\')">'.$lang['UP_AllowAll'].'</a>',
		'URL_DISALLOWALL' => '<a href="'.append_sid($HTTP_SERVER_VARS['PHP_SELF'].'?action=disallowall').'" onclick="return confirm(\''.$lang['UP_DisallowAll'].'?\')">'.$lang['UP_DisallowAll'].'</a>',
		'URL_NAVIGATION' => $str_navigation,
		'PAGINATION' => $str_pagination,
		'L_SAVE' => $lang['UP_Save'],
		'URL_SELF' => append_sid($HTTP_SERVER_VARS['PHP_SELF'])
	));


	// prepare page & output
	$template->pparse("body");

	include('./page_footer_admin.'.$phpEx);
?>